GlueGen: com.jogamp.gluegen.GlueEmitter Interface Reference

GlueGen v2.6.0-rc-20250722 GlueGen, Native Binding Generator for Java™ (public API).

Public Member Functions | List of all members
com.jogamp.gluegen.GlueEmitter Interface Reference

Specifies the interface by which GlueGen requests glue code to be generated. More...

Inheritance diagram for com.jogamp.gluegen.GlueEmitter:
Collaboration diagram for com.jogamp.gluegen.GlueEmitter:

## Public Member Functions

void | readConfigurationFile (String filename) throws Exception
JavaConfiguration | getConfig ()
void | beginEmission (GlueEmitterControls controls) throws Exception
| Begin the emission of glue code. More...
void | endEmission () throws Exception
| Finish the emission of glue code. More...
void | beginDefines () throws Exception
void | emitDefine (ConstantDefinition def, String optionalComment) throws Exception
void | endDefines () throws Exception
void | beginFunctions (TypeDictionary typedefDictionary, TypeDictionary structDictionary, Map< Type, Type > canonMap, List< FunctionSymbol > cFunctions) throws Exception
Iterator< FunctionSymbol > | emitFunctions (List< FunctionSymbol > cFunctions) throws Exception
| Emit glue code for the list of FunctionSymbols. More...
void | endFunctions () throws Exception
void | beginStructLayout () throws Exception
| Begins the process of computing field offsets and type sizes for the structs to be emitted. More...
void | layoutStruct (CompoundType t) throws Exception
| Lays out one struct which will be emitted later. More...
void | endStructLayout () throws Exception
| Finishes the struct layout process. More...
void | beginStructs (TypeDictionary typedefDictionary, TypeDictionary structDictionary, Map< Type, Type > canonMap) throws Exception
void | emitStruct (CompoundType t, Type typedefType) throws Exception
| Emit glue code for the given CompoundType. More...
void | endStructs () throws Exception

## Detailed Description

Specifies the interface by which GlueGen requests glue code to be generated.

Can be replaced to generate glue code for other languages and foreign function interfaces.

Definition at line 50 of file GlueEmitter.java.

## Member Function Documentation

## ◆ beginDefines()

void com.jogamp.gluegen.GlueEmitter.beginDefines | ( |  | ) | throws Exception

Implemented in com.jogamp.gluegen.DebugEmitter, and com.jogamp.gluegen.JavaEmitter.

Here is the caller graph for this function:

## ◆ beginEmission()

void com.jogamp.gluegen.GlueEmitter.beginEmission | ( | GlueEmitterControls | controls | ) | throws Exception

Begin the emission of glue code.

This might include opening files, emitting class headers, etc.

Implemented in com.jogamp.gluegen.DebugEmitter, and com.jogamp.gluegen.JavaEmitter.

Here is the caller graph for this function:

## ◆ beginFunctions()

void com.jogamp.gluegen.GlueEmitter.beginFunctions | ( | TypeDictionary | typedefDictionary,
|  | TypeDictionary | structDictionary,
|  | Map< Type, Type > | canonMap,
|  | List< FunctionSymbol > | cFunctions
| ) |  | throws Exception

Implemented in com.jogamp.gluegen.JavaEmitter, com.jogamp.gluegen.procaddress.ProcAddressEmitter, and com.jogamp.gluegen.DebugEmitter.

Here is the caller graph for this function:

## ◆ beginStructLayout()

void com.jogamp.gluegen.GlueEmitter.beginStructLayout | ( |  | ) | throws Exception

Begins the process of computing field offsets and type sizes for the structs to be emitted.

Implemented in com.jogamp.gluegen.DebugEmitter, and com.jogamp.gluegen.JavaEmitter.

Here is the caller graph for this function:

## ◆ beginStructs()

void com.jogamp.gluegen.GlueEmitter.beginStructs | ( | TypeDictionary | typedefDictionary,
|  | TypeDictionary | structDictionary,
|  | Map< Type, Type > | canonMap
| ) |  | throws Exception

Implemented in com.jogamp.gluegen.DebugEmitter, com.jogamp.gluegen.JavaEmitter, and com.jogamp.gluegen.procaddress.ProcAddressEmitter.

Here is the caller graph for this function:

## ◆ emitDefine()

void com.jogamp.gluegen.GlueEmitter.emitDefine | ( | ConstantDefinition | def,
|  | String | optionalComment
| ) |  | throws Exception

Parameters

  optionalComment | If optionalComment is non-null, the emitter can emit that string as a comment providing extra information about the define.

Implemented in com.jogamp.gluegen.DebugEmitter, and com.jogamp.gluegen.JavaEmitter.

Here is the caller graph for this function:

## ◆ emitFunctions()

Iterator< FunctionSymbol > com.jogamp.gluegen.GlueEmitter.emitFunctions | ( | List< FunctionSymbol > | cFunctions | ) | throws Exception

Emit glue code for the list of FunctionSymbols.

Implemented in com.jogamp.gluegen.JavaEmitter, and com.jogamp.gluegen.DebugEmitter.

Here is the caller graph for this function:

## ◆ emitStruct()

void com.jogamp.gluegen.GlueEmitter.emitStruct | ( | CompoundType | t,
|  | Type | typedefType
| ) |  | throws Exception

Emit glue code for the given CompoundType.

typedefType is provided when the CompoundType (e.g. "struct foo_t") has not been typedefed to anything but the type of "pointer to struct foo_t" has (e.g. "typedef struct foo_t {} *Foo"); in this case typedefType would be set to pointer type Foo.

Implemented in com.jogamp.gluegen.JavaEmitter, and com.jogamp.gluegen.DebugEmitter.

Here is the caller graph for this function:

## ◆ endDefines()

void com.jogamp.gluegen.GlueEmitter.endDefines | ( |  | ) | throws Exception

Implemented in com.jogamp.gluegen.DebugEmitter, and com.jogamp.gluegen.JavaEmitter.

Here is the caller graph for this function:

## ◆ endEmission()

void com.jogamp.gluegen.GlueEmitter.endEmission | ( |  | ) | throws Exception

Finish the emission of glue code.

This might include closing files, closing open class definitions, etc.

Implemented in com.jogamp.gluegen.DebugEmitter, and com.jogamp.gluegen.JavaEmitter.

Here is the caller graph for this function:

## ◆ endFunctions()

void com.jogamp.gluegen.GlueEmitter.endFunctions | ( |  | ) | throws Exception

Implemented in com.jogamp.gluegen.DebugEmitter, com.jogamp.gluegen.JavaEmitter, and com.jogamp.gluegen.procaddress.ProcAddressEmitter.

Here is the caller graph for this function:

## ◆ endStructLayout()

void com.jogamp.gluegen.GlueEmitter.endStructLayout | ( |  | ) | throws Exception

Finishes the struct layout process.

Implemented in com.jogamp.gluegen.DebugEmitter, and com.jogamp.gluegen.JavaEmitter.

Here is the caller graph for this function:

## ◆ endStructs()

void com.jogamp.gluegen.GlueEmitter.endStructs | ( |  | ) | throws Exception

Implemented in com.jogamp.gluegen.DebugEmitter, and com.jogamp.gluegen.JavaEmitter.

Here is the caller graph for this function:

## ◆ getConfig()

JavaConfiguration com.jogamp.gluegen.GlueEmitter.getConfig | ( |  | ) |

Implemented in com.jogamp.gluegen.DebugEmitter, and com.jogamp.gluegen.JavaEmitter.

Here is the caller graph for this function:

## ◆ layoutStruct()

void com.jogamp.gluegen.GlueEmitter.layoutStruct | ( | CompoundType | t | ) | throws Exception

Lays out one struct which will be emitted later.

Implemented in com.jogamp.gluegen.DebugEmitter, and com.jogamp.gluegen.JavaEmitter.

Here is the caller graph for this function:

## ◆ readConfigurationFile()

void com.jogamp.gluegen.GlueEmitter.readConfigurationFile | ( | String | filename | ) | throws Exception

Implemented in com.jogamp.gluegen.DebugEmitter, and com.jogamp.gluegen.JavaEmitter.

Here is the caller graph for this function:

The documentation for this interface was generated from the following file:

- src/java/com/jogamp/gluegen/GlueEmitter.java